{ ---------------------------------------------------------------------------------
  Example library//virscan//rose_swe AV

--------------------------------------------------------------------------------- }

{ * $Header: /home/CVS/prj/av_dll/rose_swe.pas,v 1.9 2005/03/23 18:16:54 ralproth Exp $
  ***************************************************************************
}
{ ***************************************************************************
  * $Log: rose_swe.pas,v $
  * Revision 1.9  2005/03/23 18:16:54  ralproth
  * + fixes suggested by Walla and Flo added
  *
  * Revision 1.8  2005/03/22 19:17:52  ralproth
  * + added ROSESWE_Version, pchar
  *
  * Revision 1.7  2005/03/16 16:06:32  ralproth
  * Webpage changes, misc. changes and enhancements for Permeo
  *
  * Revision 1.6  2005/03/ 10 09:20:20  ralproth
  * first public web release
  *
  * Revision 1.2  2003/10/15 18:45:11  ralproth
  * Added CVS headers, send to Andreas for pChar/String fixing
  *
  ***************************************************************************
}
{ ***************************************************************************
  * (C)opyright 1989-2005 by ROSE SWE, Dipl.Ing. Ralph Roth,
  * ROSE_SWE@hotmail.com, http://come.to/rose_swe - ALL RIGHTS RESERVED!
  *
  * Compiler:   TP 6.0 [ ]      FPC/Win32 [x]   FPC/Dos32 [ ]
  *             VPC/Win32 [ ]   VPC/Dos32 [ ]   Delphi 7  [ ]
  *
  ***************************************************************************
}


library rose_swe{_av}; { must be the same name as the executable, fixed, rar, 22.03.2005 }

uses    dos, strings, rStrings, r_utils, ansi_crc, constant, windows,
        avrvbs, avrwin32, avrmini, avrbootv, famcrypt,
        avr_troj, famvcl, famr, killer1, killer;

Const DLLVERSION = '$Id: rose_swe.pas,v 1.9 2005/03/23 18:16:54 ralproth Exp $';

{$i seekep.pas}         { Entry points of executables }

Function ScanSingleFile256(szFileIn: String; bHeuristics: Boolean): String; stdcall;

{ szFileIn: FileName of file to scan  ('C:\command.com')
  lSize:    FileSize of file to scan  (55612)
  bHeur:    Use unsafe Heuristic modules, WARNING!

  Return:

  '' (empty)            - no virus
  '[DosError] *'        - File Access Error
  '[*]'                 - known false positive, NO VIRUS at all
  '*'                   - virus

}

Var szSearch    : String;
    hIn         : File;
    r1          : Byte;
    wRes        : Word;
    lCrc32, lEP : LongInt;
    lSize       : LongInt;
    aFileBuffer : EinKilo; { Array[0..$1024] of Byte; }
    sr          : SearchRec;


Begin { ScanSingleFile }

  szSearch := '';

  findfirst(szFileIn, AnyFile, sr);
  if DosError <> 0 then
  begin
        str(DosError, szSearch);
        szSearch := '[DosError] - '+szSearch;
        ScanSingleFile256 := (szSearch);        { ###!!### }
        exit;
  end;

  if sr.size < 4 then exit;     { smallest Trojan is 4 Byte! }
  lSize := sr.size;

{ targets }
  If lSize > 32 Then
  Begin
    szSearch := AVR_Mirc(szFileIn, FALSE);        { 28.07.2001, rar }
    If szSearch = '' Then
      szSearch := AVR_VBS(szFileIn, FALSE, FALSE);      { changed/added 10.03.2005 09:57 by Ralph Roth  }
  End; { if html }

{ --- Now, file is open end read into internal buffers! }
  If (szSearch='') And (lSize >= $20) And
     FopenBin(hIn, szFileIn) Then  { <2K? access denied? }
  Begin
      For r1 := 0 To $20 Do
              aFileBuffer[r1] := 0;

    blockread(hIn, aFileBuffer, $20, wRes);      { head }

    { new, 27.05.2000 }
    lCrc32 := CheckSum(@aFileBuffer[0]);
    szSearch := Trojan_Win32(szFileIn, lSize, lCrc32 );
   (*
      writeln(hLogFile, szName+'='+hex(lCrc32,8)+', IOR='+klformat(ioresult)+
      ', sz='+szSearch+', FS='+format(sr.size));
    *)
    If szSearch = '' Then     { changed/added 16.07.2003 (22:16) by Ralph Roth }
       szSearch := Trojan_CheckPuffer(@aFileBuffer);

    If szSearch = '' Then
      Begin
         { ok, get MZ/EXE Entry Point }
         lEP := SeekEP(aFileBuffer);

         If lEP >= lSize Then
              szSearch := 'Corrupted MS-DOS Header! Size='+format(lSize)+
                          ', EP='+format(lEP)
         Else
           Begin
              seek(hin, lEP);
              blockread(hIn, aFileBuffer, sizeof(aFileBuffer), wRes);
              szSearch := AVR_MemCodes(@aFileBuffer, wRes, bHeuristics);
             {calls AVR_BOOTVIRUS! }
              { szSearch := AVR_BOOTVIR(@aFileBuffer, wRes, TRUE); }
           End;
         If szSearch = '' Then
              szSearch := AVR_CRYPTCOM(@aFileBuffer, {wRes,} bHeuristics);
         If szSearch = '' Then
              szSearch := AVR_VCL(@aFileBuffer, bHeuristics);
         If szSearch = '' Then
              szSearch := AVR_CallNull(@aFileBuffer, FALSE, FALSE);
         If szSearch = '' Then
              szSearch := AVR_Mini(@aFileBuffer, bHeuristics, wRes);
         If szSearch = '' Then If AVR_Cybertech(@aFileBuffer) Then
                                 szSearch := 'Cybertech';
         If szSearch = '' Then
              szSearch := AVR_Sonstige(@aFileBuffer, bHeuristics, wRes);
         If szSearch = '' Then
              szSearch := AVR_QUX(@aFileBuffer, bHeuristics);
         If szSearch = '' Then
              szSearch := AVR_Vienna(@aFileBuffer, TRUE {bHeuristics});
         If szSearch = '' Then
              szSearch := AVR_Weizen(@aFileBuffer, TRUE {bHeuristics});
         If szSearch = '' Then
              szSearch := AVR_WordSwap(@aFileBuffer, bHeuristics);
         If szSearch = '' Then
              szSearch := AVR_Natas(@aFileBuffer, wRes, bHeuristics);
         If szSearch = '' Then If AVR_Haifa(@aFileBuffer) Then
                                 szSearch := 'Haifa';
         If szSearch = '' Then
              szSearch := AVR_Manzon(@aFileBuffer);
       { --- killer.pas }
          If szSearch = '' Then
              szSearch := AVR_DumbVirus(@aFileBuffer, wRes, bHeuristics);
         If szSearch = '' Then
              szSearch := AVR_WashBurn(@aFileBuffer, wRes, bHeuristics);

      { --- triggers sometimes FP, therefore as last AVR module! }
         if bHeuristics then
         begin
           If szSearch = '' Then        { act. no virus detection! }
              szSearch := AVR_StackDec(@aFileBuffer, bHeuristics);
           If szSearch = '' Then If AVR_Malta(@aFileBuffer) Then
              szSearch := 'Malta';
         end; {heur}
      End;
      { ---- Closed! ---- }
      close(hIn);
      If ioresult <> 0 Then   { pascal simly sucks here };
    End;

  ScanSingleFile256 := (szSearch);  { ###!!### }

End; { ScanSingleFile256 }

{ ------------------------------------------------------------------------ }

Function ScanSingleFile(pC: pChar; bHeur : Boolean) : pChar;

var  szTmp : String;
     pRes  : pChar;

begin { ssf }

        szTmp := {strpas}String(pC);
        { ssf256(String, Boolean) : String; }
        szTmp := ScanSingleFile256(szTmp, bHeur);
        pRes  := (pChar((szTmp)));
        ScanSingleFile := pRes;

end;  { ssf }
{ ------------------------------------------------------------------------- }

Procedure FileNotFound(szFile: String);

begin { FileNotFound }

       MessageBox(GetDesktopWindow, 'Signaturefile not found!' , 'ROSE_SWE DLL:Init - Fatal Error', MB_ICONSTOP or MB_OK);

       writeln(GuruHeadLine('DLL:Init - Fatal Error'));
       writeln('File: '+szFile+' not found!');
       halt(8);

end; { FileNotFound }

{ ------------------------------------------------------------------------- }


Procedure DLL_Init_ROSE_SWE;

var szParam: ShortString;

begin
  { those SIG files are needed! }
  if not existonpath('virscan.wsm', szParam) then       { vbs -> wsm }
        FileNotFound(szParam);
  if not existonpath('virscan.irc', szParam) then
        FileNotFound(szParam);
  if not existonpath('virscan.trj', szParam) then       { changed/added 14.10.2003 (19:12) by Ralph Roth }
        FileNotFound(szParam);
  Trojan_Init;
  Verify_AVRVBS;        { checks the signature files for tampering! 12.02.2005 23:06 }

end;

{ ------------------------------------------------------------------------- }


Function ROSESWE_Version : PChar; stdcall;
begin
        ROSESWE_Version := DLLVERSION;
end;

{ ------------------------------------------------------------------------- }


exports ScanSingleFile, ROSESWE_Version {, DLL_Init_ROSE_SWE };

{ --------------------------------------------------------------------------------- }

begin
       DLL_Init_ROSE_SWE;  { Showmessage('VirScan.DLL by ROSE SWE'); }
       MessageBox(GetDesktopWindow, 'ROSE_SWE - DLL Startup Code reached' , 'VirScan.DLL by ROSE SWE -'+DLLVERSION, MB_OK);

end.


