#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern char* ScanSingleFile(char*, int);
extern char* ROSESWE_Version(void);

int main(int argc, char *argv[])
{
    int		nT;
    char 	szFile[1024*8];
    

    printf("Test ROSE_SWE DLL in C (%s)\n", __DATE__);
    printf("DLL Version = %s\nusage: %s filespec\n", ROSESWE_Version(), argv[0]);
    printf("$Id: test_dll_c.c,v 1.2 2005/03/28 16:05:49 ralproth Exp $\n");
    nT = argc;
    printf("Checking %i file(s)\n\n", nT);
    
    if (argc<2)
    {
        puts("usage: test_dll filespec");
        return 1;
    };

    while (--nT > 0)
    {
     	printf("# %d: ", nT);  	
        strcpy(szFile, argv[nT]);
        printf("%s -> '%s'\n", szFile, ScanSingleFile(szFile, 0));
    }


    return 0;
}


/*
Folgendes ist zu beachten:

1. Beim Import der Funktionen in die Delphi Unit, mssen die Funktionen mit stdcall deklariert sein.
2. Bei bergabe von Zeichenketten mssen nullterminierte Strings bergeben werden  die Pascal Entsprechung heit PChar.

Import:

ausblenden anzeigen Sourcecode
   ausgeblendet 	markieren
1:
	
function SendString(Str: PChar): boolean; stdcall; external 'XY.dll';


Aufruf:

Var
  IniPath: string
Begin
  IniPath := 'C:\ini.ini';
  SendString(PChar(iniPath));

Als Literatur Tip kann ich die Online Hilfe von Delphi nennen :D
einfach mal DLL eingeben! 

*/
